/* Dave Pallot */
/* pallot@iinet.net.au */
/* Copyright 2000 */

#include "Semaphore.h"

Semaphore::Semaphore()
{
	m_handle = ::CreateSemaphore((SECURITY_ATTRIBUTES*)0, 0, 1024, 0);
}

Semaphore::~Semaphore()
{
	if (m_handle != NULL)
	{
		::CloseHandle(m_handle);
	}
}

unsigned int Semaphore::wait(unsigned int nSec)
{	
	DWORD waitRetCode = WAIT_FAILED;

	if (m_handle)
	{
		waitRetCode = ::WaitForSingleObject(m_handle, nSec);
	}

	return waitRetCode;
}

void Semaphore::signal()
{
	if (m_handle)
	{
		::ReleaseSemaphore(m_handle, 1, NULL);
	}
}

unsigned int Semaphore::wait()
{
	return wait(INFINITE);
}

